﻿package {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.geom.ColorTransform;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	public class main extends MovieClip {
		
		private var stageMc;
		private var xmlData:XML;
		private var xmlLoader:URLLoader;
		private var myGridMc:MovieClip;
		private var myGridExpMc:MovieClip;
		private var maxCor:Number=0;
		private var gridStartX:Number=0;
		private var gridStartY:Number=0;
		private var XCor:Number=0;
		private var YCor:Number=0;
		private var gridArea:Number=0;
		private var unitGridWid:Number=0;
		private var xScal:MovieClip;
		private var yScal:MovieClip;
		private var myGridArray:Array=[[[0,0]],[[0,0],[0,0]],[[0,0],[0,0],[0,0],[0,0]]];
		private var myGridColorArray:Array=[];
		private var myHintColorArray:Array=[];
		private var myExpPosArray:Array=[];
		private var hintLevel:Number=0;
		private var myAnswer:Number=0;
		private var activityStart:Boolean=false;
		private var currFocusObj;
		private var currNull:Boolean=false;

		public function main() {
			stageMc=this;
			setMc.visible=false;
			xmlLoader = new URLLoader();
			xmlLoader.load(new URLRequest("data.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, loadXml);
			
		}
		
		private function loadXml(eve:Event)
		{
			xmlData = new XML(eve.target.data);
			gridStartX = xmlData.children()[0].attribute("xpos");
			gridStartY = xmlData.children()[0].attribute("ypos");
			gridArea = xmlData.children()[0].attribute("gridArea");
			maxCor = xmlData.children()[0].attribute("maxGrid");
			
			for(var i=1; i<=xmlData.children()[0].children().length(); i++){
				var myArr = [];
				for(var j=1; j<=xmlData.children()[0].children()[i-1].children().length(); j++){
					myArr.push(xmlData.children()[0].children()[i-1].children()[j-1].attribute("colour"));
				}
				myGridColorArray.push(myArr);
			}
			
			for(i=1; i<=xmlData.children()[1].children().length(); i++){
				myHintColorArray.push(xmlData.children()[1].children()[i-1].attribute("colour"));
			}
			
			for(i=1; i<=xmlData.children()[2].children().length(); i++){
				myExpPosArray[i-1] =[];
				myExpPosArray[i-1].push(xmlData.children()[2].children()[i-1].attribute("xpos"));
				myExpPosArray[i-1].push(xmlData.children()[2].children()[i-1].attribute("ypos"));
			}
			
			startActivity();		
			
		}

		private function startActivity() {
			myGridMc = new MovieClip();
			myGridMc.name="myGridMc";
			myGridMc.x=gridStartX;
			myGridMc.y=gridStartX;
			stageMc.addChild(myGridMc);
			myGridExpMc = new MovieClip();
			myGridExpMc.name="myGridExpMc";
			stageMc.addChild(myGridExpMc);
			xScal = new coorMc();
			stageMc.addChild(xScal);
			yScal = new coorMc();
			stageMc.addChild(yScal);
			reset_btn.buttonMode=true;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			//hintMc.buttonMode=true;
			hintMc.addEventListener(MouseEvent.CLICK, showHint);
			//hintMc.addEventListener(MouseEvent.MOUSE_OVER, mouseOverEvent);
			//hintMc.addEventListener(MouseEvent.MOUSE_OUT, mouseOutEvent);
			//undoHintMc.buttonMode=true;
			undoHintMc.addEventListener(MouseEvent.CLICK, undoHint);
			//undoHintMc.addEventListener(MouseEvent.MOUSE_OVER, mouseOverEvent);
			//undoHintMc.addEventListener(MouseEvent.MOUSE_OUT, mouseOutEvent);
			//setArrMc.buttonMode=true;
			setArrMc.addEventListener(MouseEvent.CLICK, showSetMc);
			//setArrMc.addEventListener(MouseEvent.MOUSE_OVER, mouseOverEvent);
			//setArrMc.addEventListener(MouseEvent.MOUSE_OUT, mouseOutEvent);
			setMc.setBtnMc.buttonMode=true;
			setMc.setBtnMc.addEventListener(MouseEvent.CLICK, onSetClick);
			setMc.addEventListener(MouseEvent.MOUSE_OVER, mouseOverEvent);
			setMc.addEventListener(MouseEvent.MOUSE_OUT, mouseOutEvent);
			
			for (var i=0; i<=9; i++) {
				var myDigit=keyPadMc["digit"+i];
				myDigit.num=i;
				myDigit.buttonMode=true;
				myDigit.addEventListener(MouseEvent.CLICK, onDigiEnter);
				//myDigit.addEventListener(MouseEvent.MOUSE_OUT, onDigiExit);
				//myDigit.addEventListener(MouseEvent.MOUSE_UP, onDigiExit);
			}
			var myBackBtn=keyPadMc["backBtn"];
			//myBackBtn.buttonMode=true;
			myBackBtn.addEventListener(MouseEvent.CLICK, onBackEnter);
			//myBackBtn.addEventListener(MouseEvent.MOUSE_OVER, mouseOverEvent);
			//myBackBtn.addEventListener(MouseEvent.MOUSE_OUT, mouseOutEvent);
			generateCoordinates();
			drawGrid();

		}
		
		function mouseOverEvent(e:Event)
		{
			e.currentTarget.gotoAndStop(2);
		}
		function mouseOutEvent(e:Event)
		{
			e.currentTarget.gotoAndStop(1);
		}
		
		/*private function onDigiExit(obj:MouseEvent)
		{
			obj.currentTarget.gotoAndStop(1);
		}*/
		
		private function onDigiEnter(obj:MouseEvent) {
			
			for (var i=0; i<=9; i++) {
				var myDigit=keyPadMc["digit"+i];
				myDigit.gotoAndStop(1);
			}
			//obj.currentTarget.gotoAndStop(2);
			var myObj=currFocusObj;
			
			if (myObj!=null) {
				if (currNull==true) {
					myObj.text="";
					currNull=false;
				}
				
				
				myObj.text+=obj.currentTarget.num;
				stageMc.stage.focus=myObj;
				
				myObj.dispatchEvent(new Event(Event.CHANGE));
			}
		}

		private function onBackEnter(obj:MouseEvent) {
			//obj.currentTarget.gotoAndStop(3);
			var myObj=currFocusObj;
			if (myObj!=null) {
				var myText=myObj.text;
				(myText!="")?(myText = myText.substr(0, (myText.length-1))):"";
				myObj.text=myText;
				myObj.dispatchEvent(new Event(Event.CHANGE));
				if (myObj.text=="") {
					currNull=true;
				}
			}
		}

		private function showSetMc(obj:MouseEvent) {
			//obj.currentTarget.gotoAndStop(3);
			setMc.visible=! setMc.visible;
			if (! setMc.visible) {
				appendArrayValues();
				drawGrid();
			}
		}

		private function onSetClick(obj:MouseEvent) {
			///obj.currentTarget.gotoAndStop(3);
			obj.currentTarget.play();
			setMc.visible=false;
			appendArrayValues();
			drawGrid();
		}

		private function generateCoordinates() {
			feedbackMc.visible=false;
			setMc.visible=false;
			XCor = Math.floor(Math.random()*(maxCor-1))+2;
			YCor = Math.floor(Math.random()*(maxCor-1))+2;
			//XCor=25;
			//YCor=18;
			xScal.txt.text=XCor;
			yScal.txt.text=YCor;
		}

		private function drawGrid() {
			removeClips();
			feedbackMc.visible=false;
			xScal.txt.text=XCor;
			yScal.txt.text=YCor;
			myAnswer=(XCor*YCor);
			var myVal=Math.max(XCor,YCor);
			unitGridWid = Math.round((gridArea-50)/(myVal));
			if (activityStart==false) {
				setArrayValues();
				activityStart=true;
			}
			//(activityStart==false)?(setArrayValues() & activityStart=true):"";
			var gridX=0;
			var gridY=0;
			var myHintLevel = (hintLevel>2)?2:hintLevel;
			for (var k=1; k<=myGridArray[myHintLevel].length; k++) {
				var myGridHolder = new MovieClip();
				myGridHolder.x=gridX;
				myGridHolder.y=gridY;
				myGridHolder.name="Grid"+k;
				myGridMc.addChild(myGridHolder);
				var xPos=0;
				var yPos=0;
				var myGridWidth=0;
				for (var i=1; i<=myGridArray[myHintLevel][k-1][1]; i++) {
					for (var j=1; j<=myGridArray[myHintLevel][k-1][0]; j++) {
						var gridMc = new Sprite();
						gridMc.name="gridMc_"+i;
						gridMc.graphics.beginFill(myGridColorArray[myHintLevel][k-1]);
						gridMc.graphics.lineStyle(1,"0x000000");
						gridMc.graphics.drawRect(0, 0, unitGridWid, unitGridWid);
						gridMc.x=xPos+((j-1)*unitGridWid);
						gridMc.y=yPos;
						myGridHolder.addChild(gridMc);
					}
					yPos+=unitGridWid;
				}
				myGridWidth=myGridHolder.width;
				if (myHintLevel>0) {
					var myHintExp = new hintExpMc();
					myHintExp.name="myHintExp"+k;
					var myAns=myGridArray[myHintLevel][k-1][0]*myGridArray[myHintLevel][k-1][1];

					var colorTransform:ColorTransform=myHintExp["bgMc"].transform.colorTransform;
					colorTransform.color=myHintColorArray[k-1];
					myHintExp["bgMc"].transform.colorTransform=colorTransform;
					myHintExp.x = (myGridHolder.width/2);
					myHintExp.y = (myGridHolder.height/2);
					myGridHolder.addChild(myHintExp);
					var myString:String=String(myGridArray[myHintLevel][k-1][0])+" x "+String(myGridArray[myHintLevel][k-1][1])+" = "+String(myAns);
					//myHintExp.myTxt.restrict = "0-9 x";
					myHintExp.myTxt.text=myString;
					if (k%2==0) {
						gridX=0;
						gridY=myGridMc.height+30;
					} else {

						var myHint=myGridHolder.getChildByName("myHintExp"+k);
						if ((myHint.x-(myHint.width/2))<0) {
							while ((myGridHolder.x-((myHint.width-myGridWidth)/2))<0) {
								myGridHolder.x+=1;
							}
							gridX=(myGridHolder.x+myGridWidth+((myHint.width-myGridWidth)/2))+30;
						} else {
							gridX=(myGridHolder.x+myGridHolder.width)+30;
						}
					}
				}
				if (myGridHolder.numChildren==1) {
					//myGridHolder.y += (myGridHolder.height/2);
					var myValU=0;
					if (myGridArray[myHintLevel][k-1][0]!=0) {
						myValU=((myGridArray[myHintLevel][k-1][0]/2)*unitGridWid);
						myGridHolder.x+=myValU;
						if ((k%2!=0)&&(myGridArray[myHintLevel][k-1][1]==0)) {
							myGridHolder.x -= (myGridHolder.width/2);
						}
						//(myGridHolder.x!=myValU)?myGridHolder.x += myValU:"";
					}
					if (myGridArray[myHintLevel][k-1][1]!=0) {
						myValU=((myGridArray[myHintLevel][k-1][1]/2)*unitGridWid);
						myGridHolder.y+=myValU;
					}
					if (myGridArray[myHintLevel][k-1][0]==0 && myGridArray[myHintLevel][k-1][1]==0 && (k%2==0)) {
						myValU=((myGridArray[myHintLevel][k-2][0])*unitGridWid);
						myGridHolder.x+=myValU;
						myGridHolder.x-=myGridHolder.width;
						//myGridHolder.x -= (myGridHolder.width/2);
					}
					while ((myGridHolder.y-((myGridHolder.height)/2))<0) {
						myGridHolder.y+=1;
					}

				}

			}
			for (k=0; k<=myHintLevel; k++) {
				var myExpMc = new expMc();
				myExpMc.name="myExpMc"+k;
				myExpMc.x=myExpPosArray[k][0];
				myExpMc.y=myExpPosArray[k][1];
				myGridExpMc.addChild(myExpMc);
				var expression="";
				if (k==0) {
					expression=setMc.x1.text+"  x  "+setMc.y1.text+"  =";
					myExpMc.expTxt.text=expression;
				} else if (k==1) {
					//
					expression = (Number(setMc.x1_1.text)*Number(setMc.y1.text))+"  +  "+(Number(setMc.x1_2.text)*Number(setMc.y1.text))+"  =";
					myExpMc.expTxt.text=expression;
				} else if (k==2) {
					expression = (Number(setMc.x1_1.text)*Number(setMc.y1_1.text))+"  +  "+(Number(setMc.x1_2.text)*Number(setMc.y1_1.text))+"  +  "+(Number(setMc.x1_1.text)*Number(setMc.y1_2.text))+"  +  "+(Number(setMc.x1_2.text)*Number(setMc.y1_2.text))+"  =";
					myExpMc.expTxt.text=expression;

				}

				myExpMc.ansTxt.text="";
				myExpMc.ansTxt.restrict="0-9";
				myExpMc.ansTxt.maxChars=4;
				myExpMc.ansTxt.addEventListener(Event.CHANGE, onAnsChange);
				myExpMc.ansTxt.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);		
				
				currFocusObj=myExpMc.ansTxt;
				stageMc.stage.focus=myExpMc.ansTxt;			
			}
			if (hintLevel==3) {
				myExpMc.ansTxt.text=myAnswer;
				myExpMc.ansTxt.dispatchEvent(new Event(Event.CHANGE));
			}
			xScal.x = myGridMc.x+(myGridMc.width/2);
			xScal.y = myGridMc.y-(xScal.height/2);
			yScal.x = myGridMc.x-(yScal.width/2);
			yScal.y = myGridMc.y+(myGridMc.height/2);

		}

		private function onAnsChange(evt:Event) {
			var myText=evt.currentTarget.text;
			var myHintLevel = (hintLevel>2)?2:hintLevel;
			
			for (var k=0; k<=myHintLevel; k++) {
				var myExpMc=myGridExpMc.getChildByName("myExpMc"+k);
				if(myExpMc.ansTxt.length<=4)
				{
					myExpMc.ansTxt.text=myText;
				}
			}
			if (Number(myText)==myAnswer) {
				feedbackMc.visible=true;
			} else {
				feedbackMc.visible=false;
			}
			
			currFocusObj=evt.currentTarget;
			stageMc.stage.focus=evt.currentTarget;			
			currFocusObj.setSelection(currFocusObj.text.length,currFocusObj.text.length);
		}

		private function setArrayValues() {
			setMc.x1.text=XCor;
			setMc.y1.text=YCor;
			setMc.x1.addEventListener(Event.CHANGE, onCorChange);
			setMc.y1.addEventListener(Event.CHANGE, onCorChange);
			setMc.x1.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.y1.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.x1.addEventListener(FocusEvent.FOCUS_OUT, onCorFocusOut);
			setMc.y1.addEventListener(FocusEvent.FOCUS_OUT, onCorFocusOut);
			setMc.x1_1.text=Math.floor(XCor/2);
			setMc.x1_2.text=Math.ceil(XCor/2);
			setMc.y1_1.text=Math.floor(YCor/2);
			setMc.y1_2.text=Math.ceil(YCor/2);
			setMc.x1_1.addEventListener(Event.CHANGE, onCorPartChange);
			setMc.x1_2.addEventListener(Event.CHANGE, onCorPartChange);
			setMc.y1_1.addEventListener(Event.CHANGE, onCorPartChange);
			setMc.y1_2.addEventListener(Event.CHANGE, onCorPartChange);
			setMc.x1_1.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.x1_2.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.y1_1.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.y1_2.addEventListener(FocusEvent.FOCUS_IN, onFocusIn);
			setMc.x1_1.addEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
			setMc.x1_2.addEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
			setMc.y1_1.addEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
			setMc.y1_2.addEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
			appendArrayValues();

		}

		private function onFocusIn(focEvt:FocusEvent) {
			if (currFocusObj!=focEvt.currentTarget) {
				currNull=false;
				if(currFocusObj.name!="ansTxt"){
					if(String(currFocusObj.name).length>2){
						currFocusObj.addEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
						currFocusObj.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
					}else{
						currFocusObj.addEventListener(FocusEvent.FOCUS_OUT, onCorFocusOut);
						currFocusObj.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
					}
				}
			}else{
				if(currFocusObj.name!="ansTxt"){
					if(String(currFocusObj.name).length>2){
						currFocusObj.removeEventListener(FocusEvent.FOCUS_OUT, onCorPartFocusOut);
					}else{
						currFocusObj.removeEventListener(FocusEvent.FOCUS_OUT, onCorFocusOut);
					}
				}
			}
			currFocusObj=focEvt.currentTarget;
		}

		private function onCorPartFocusOut(focEvt:FocusEvent) {
			var boxNam=focEvt.currentTarget.name.substr(0,1);
			var boxNum=focEvt.currentTarget.name.substr(-1);
			var myCorText=0;
			if (boxNam=="x") {
				myCorText=XCor;
			} else {
				myCorText=YCor;
			}
			if (boxNum=="1") {
				var myBox1=setMc.getChildByName(boxNam+"1_2");
				focEvt.currentTarget.text = (myCorText-myBox1.text);
			} else {
				var myBox2=setMc.getChildByName(boxNam+"1_1");
				focEvt.currentTarget.text = (myCorText-myBox2.text);
			}
			
			appendArrayValues();
		}

		private function onCorFocusOut(focEvt:FocusEvent) {
			var boxNam=focEvt.currentTarget.name.substr(0,1);
			if (currNull==false) {
				if (boxNam=="x") {
					focEvt.currentTarget.text=XCor;
				} else {
					focEvt.currentTarget.text=YCor;
				}
			}
		}

		private function onCorPartChange(evt:Event) {
			if (evt.currentTarget.text!="") {
				var boxNam=evt.currentTarget.name.substr(0,1);
				var myText=Number(evt.currentTarget.text);
				var myCorText=0;
				if (boxNam=="x") {
					myCorText=XCor;
				} else {
					myCorText=YCor;
				}
				if (myText>myCorText) {
					switch (evt.currentTarget.name) {
						case "x1_1" :
							evt.currentTarget.text=myGridArray[1][0][0];
							break;

						case "x1_2" :
							evt.currentTarget.text=myGridArray[1][1][0];
							break;

						case "y1_1" :
							evt.currentTarget.text=myGridArray[2][0][1];
							break;

						case "y1_2" :
							evt.currentTarget.text=myGridArray[2][2][1];
							break;
					}

				}
				if (evt.currentTarget.name.substr(-1)=="1") {
					var myBox1=setMc.getChildByName(boxNam+"1_2");
					myBox1.text = (myCorText-evt.currentTarget.text);
				} else {
					var myBox2=setMc.getChildByName(boxNam+"1_1");
					myBox2.text = (myCorText-evt.currentTarget.text);
				}
				appendArrayValues();
			}
			//appendArrayValues();
			//stageMc.stage.focus=evt.currentTarget;
			currFocusObj=evt.currentTarget;
		}

		private function onCorChange(evt:Event) {
			var boxNam=evt.currentTarget.name.substr(0,1);
			var myText=Number(evt.currentTarget.text);
			var myCorText=0;
			if (boxNam=="x") {
				myCorText=XCor;
			} else {
				myCorText=YCor;
			}
			
			if (myText>1&&myText<=maxCor) {
				var myBox1=setMc.getChildByName(boxNam+"1_1");
				myBox1.text=Math.floor(myText/2);
				var myBox2=setMc.getChildByName(boxNam+"1_2");
				myBox2.text=Math.ceil(myText/2);
			}
			if (myText>maxCor) {
				evt.currentTarget.text=myCorText;
			}
			if (myText>1) {
				if (boxNam=="x") {
					XCor=evt.currentTarget.text;
				} else {
					YCor=evt.currentTarget.text;
				}
				appendArrayValues();
			}
			
			//appendArrayValues();
			//stageMc.stage.focus=evt.currentTarget;
			currFocusObj=evt.currentTarget;
		}

		private function appendArrayValues() {
			setMc.x1.text=XCor;
			setMc.y1.text=YCor;
			//setMc.x1_1.text=Math.floor(XCor/2);
			//setMc.x1_2.text=Math.ceil(XCor/2);
			//setMc.y1_1.text=Math.floor(YCor/2);
			//setMc.y1_2.text=Math.ceil(YCor/2);
			myGridArray[0][0][0]=XCor;
			myGridArray[0][0][1]=YCor;

			myGridArray[1][0][0]=Number(setMc.x1_1.text);
			myGridArray[1][0][1]=YCor;
			myGridArray[1][1][0]=Number(setMc.x1_2.text);
			myGridArray[1][1][1]=YCor;

			myGridArray[2][0][0]=Number(setMc.x1_1.text);
			myGridArray[2][0][1]=Number(setMc.y1_1.text);
			myGridArray[2][1][0]=Number(setMc.x1_2.text);
			myGridArray[2][1][1]=Number(setMc.y1_1.text);
			myGridArray[2][2][0]=Number(setMc.x1_1.text);
			myGridArray[2][2][1]=Number(setMc.y1_2.text);
			myGridArray[2][3][0]=Number(setMc.x1_2.text);
			myGridArray[2][3][1]=Number(setMc.y1_2.text);
		}

		private function removeClips() {
			while (myGridMc.numChildren) {
				myGridMc.removeChildAt(0);
			}
			while (myGridExpMc.numChildren) {
				myGridExpMc.removeChildAt(0);
			}
		}

		private function onReset(obj:MouseEvent) {
			activityStart=false;
			generateCoordinates();
			hintLevel=0;
			drawGrid();
		}

		private function showHint(obj:MouseEvent) {
			//obj.currentTarget.gotoAndStop(3);
			if (setMc.visible) {
				setMc.visible=false;
				appendArrayValues();
			} else {
				if (hintLevel<2) {
					hintLevel++;
				}
				drawGrid();
			}
		}

		private function undoHint(obj:MouseEvent) {
			//obj.currentTarget.gotoAndStop(3);
			if (setMc.visible) {
				setMc.visible=false;
				appendArrayValues();
			} else {
				if (hintLevel>0) {
					hintLevel--;
				}
				drawGrid();
			}
		}
	}
}