﻿package  {
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.MovieClip;
	
	public class ILMethod extends MovieClip {
		
		private var selectedGrid:Number=1;;
		
		public function ILMethod() {
			// constructor code
			initialize()
		}
		
		private function initialize()
		{
			grid2.visible=false;
			grid2.alpha=1;
			grid3.visible=false;
			grid3.alpha=1;
			gridBtn1.gotoAndStop(3);
			
			buttonEvent(gridBtn1,setSelectedGrid);
			buttonEvent(gridBtn2,setSelectedGrid);
			buttonEvent(gridBtn3,setSelectedGrid);
			
			nProbBtn.buttonMode=true;
			nProbBtn.addEventListener(MouseEvent.MOUSE_OVER, npMouseOver,true);
			nProbBtn.addEventListener(MouseEvent.MOUSE_OUT, npMouseOut,true);
			nProbBtn.addEventListener(MouseEvent.MOUSE_UP, npMouseOut,true);
			nProbBtn.addEventListener(MouseEvent.MOUSE_DOWN, npMouseDwn,true);
			nProbBtn.addEventListener(MouseEvent.CLICK, setNewProblem,true);
			
			
			grid1.resultValue.addEventListener(Event.CHANGE, checkValue,false);
			grid2.resultValue.addEventListener(Event.CHANGE, checkValue,false);
			grid3.resultValue.addEventListener(Event.CHANGE, checkValue,false);
			
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		function npMouseOver(e:MouseEvent)
		{
			e.target.parent.gotoAndStop(2);
		}
		function npMouseOut(e:MouseEvent)
		{
			
			e.target.parent.gotoAndStop(1);
		}
		function npMouseDwn(e:MouseEvent)
		{
			
			e.target.parent.gotoAndStop(3);
		}	
			
		
		private function buttonEvent(obj,methodName)
		{
			obj.buttonMode=true;
			obj.addEventListener(MouseEvent.CLICK, methodName,true);
			
			obj.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver,true);
			obj.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut,true);
			obj.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDwn,true);
			
			
		}
		function onMouseOver(e:MouseEvent)
		{
			if(e.target.parent.currentFrame!=3)
			{
				e.target.parent.gotoAndStop(2);
			}
		}
		function onMouseOut(e:MouseEvent)
		{
			if(e.target.parent.currentFrame!=3)
			{
				e.target.parent.gotoAndStop(1);
			}
			nProbBtn.gotoAndStop(1);
		}
		function onMouseDwn(e:MouseEvent)
		{			
			if(e.target.parent.name!="nProbBtn")
			{			
				gridBtn1.gotoAndStop(1);
				gridBtn2.gotoAndStop(1);
				gridBtn3.gotoAndStop(1);
			}
			e.target.parent.gotoAndStop(3);
		}
		
		function setSelectedGrid(e:MouseEvent)
		{	
			changeGrid(e.target.parent.name)
		}
		 
		private function changeGrid(gridName)
		{			
			switch(gridName)
			{
				case "gridBtn1":
				selectedGrid=1;
				clearTextField(2,2);
				grid2.visible=grid3.visible=false;
				grid1.visible=true;
				break;
				case "gridBtn2":				
				selectedGrid=2;
				clearTextField(3,2);
				grid1.visible=grid3.visible=false;
				grid2.visible=true;
				break;
				case "gridBtn3":				
				selectedGrid=3;
				clearTextField(3,3);
				grid1.visible=grid2.visible=false;
				grid3.visible=true;
				break;
				
			}
			
		}
		
		function setNewProblem(e:MouseEvent)
		{			
			
			
			switch(selectedGrid)
			{
				case 1:
				clearTextField(2,2);
				grid1.pValue1.text=Math.floor(Math.random()*(99-10))+10;
				grid1.pValue2.text=Math.floor(Math.random()*(99-10))+10;					
				break;
				case 2:
				clearTextField(3,2);
				grid2.pValue1.text=Math.floor(Math.random()*(999-100))+100;
				grid2.pValue2.text=Math.floor(Math.random()*(99-10))+10;				
				break;
				case 3:
				clearTextField(3,3);
				grid3.pValue1.text=Math.floor(Math.random()*(999-100))+100;
				grid3.pValue2.text=Math.floor(Math.random()*(999-100))+100;
				break;			
				
			}			
			
		}
		
		function checkValue(e:Event)
		{
			var value1=e.target.parent.pValue1.text;
			var value2=e.target.parent.pValue2.text;
			trace(value1);
			if((e.target.text==value1*value2) && (value1!="" && value2!=""))
			{				
				e.target.parent.parent.tick.alpha=1;
				e.target.parent.parent.cross.alpha=0;
				
			}else
			{
				e.target.parent.parent.tick.alpha=0;
				e.target.parent.parent.cross.alpha=1;
				
			}
			if(e.target.text=="")
			{
				e.target.parent.parent.tick.alpha=0;
				e.target.parent.parent.cross.alpha=0;
				
			}
		}
		
		private function clearTextField(column,row)
		{
			this.tick.alpha=0;
			this.cross.alpha=0;
			var noAns:Number=column+row;
			
			var currentGrid:MovieClip=new MovieClip();
			currentGrid=this["grid"+selectedGrid];
			currentGrid.pValue1.text="";
			currentGrid.pValue2.text="";
			currentGrid.resultValue.text="";
			
			for(var noRow:int=1;noRow<=row;noRow++)
			{
				
				for(var noColumn:int=1;noColumn<=column;noColumn++)
				{					
					currentGrid["vTxt"+noColumn].text="";
					
					currentGrid["g"+String(noRow)+String(noColumn)+"a"].text="";
					currentGrid["g"+String(noRow)+String(noColumn)+"b"].text="";
				}
				
				currentGrid["hTxt"+noRow].text="";
			}
			
			for(var ans=noAns;ans>0;ans--)
			{
				
				currentGrid["ansTxt"+ans].text="";
				
			}
			
		}
		
		function reset(e:MouseEvent)
		{
			changeGrid("gridBtn1");
		}

	}
	
}
