﻿package  {
	
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	public class FlipBook extends MovieClip {
		private var units:Array=new Array("Tens thousands","Thousands","Hundreds","Tens","Units")
		private var hideBook1:Boolean= false;
		private var hideBook2:Boolean=false;
		private var noFlipBook:Number=5;
		private var newBook:MovieClip;
		
		public function FlipBook() {
			// constructor code
			initialize()
		}
		
		private function initialize()
		{
			
			for(var i:int=0;i<units.length;i++)
			{				
				newBook=new fBook();
				newBook.name="book"+i;				
				newBook.x=25+(145*i);
				newBook.y=140;
				newBook.digitsTxt.text=units[i];
				newBook.numTxt.text=0;
				
				clickEvent(newBook.upArrow,increaseValue);
				clickEvent(newBook.downArrow,decreaseValue);				
				this.addChild(newBook);
				
			}
			
			
			clickEvent(hide1,hideTenThousand);
			clickEvent(hide2,hideThousand);	
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		private function clickEvent(obj,methodName)
		{
			obj.buttonMode=true;
			obj.addEventListener(MouseEvent.CLICK, methodName,false);
			
		}
		
		
		
		
		function increaseValue(e:MouseEvent)
		{
			
			var cardValue:Number=e.target.parent.numTxt.text;
			if(cardValue<9)
			{
				cardValue=cardValue+1
			}else
			{
				cardValue=0;
			}
			e.target.parent.numTxt.text=cardValue;
		}
		function decreaseValue(e:MouseEvent)
		{
			
			var cardValue:Number=e.target.parent.numTxt.text;
			if(cardValue>0)
			{
				cardValue=cardValue-1
			}else
			{
				cardValue=9;
			}
			e.target.parent.numTxt.text=cardValue;
		}
		
		function hideTenThousand(e:MouseEvent)
		{
			
			if(!hideBook1)
			{
				hideBook1=true;
				noFlipBook=4;
				e.target.parent.gotoAndStop(2);	
				
			}else
			{
				hideBook1=false;
				noFlipBook=5;
				e.target.parent.gotoAndStop(1);
				hideBook2=false;
				
			}
			
			
			CheckHide2Btn();
			reArrangeFilipBook();
		}
		function CheckHide2Btn(){
			if(noFlipBook==4){
				hide2.gotoAndStop(1);
			}
			if(hide1.currentFrame==1) hide2.gotoAndStop(1);
			
		}
		
		function hideThousand(e:MouseEvent)
		{			
			if(!hideBook2)
			{
				hideBook2=true;
				noFlipBook=3;
				e.target.parent.gotoAndStop(2);
				hide1.gotoAndStop(2);
				hideBook1=true;
			}else
			{
				hideBook2=false;
				noFlipBook=4;
				e.target.parent.gotoAndStop(1);				
			}
			CheckHide2Btn()
			reArrangeFilipBook();
		}
		
		private function reArrangeFilipBook()
		{		
			for(var i:int=0;i<5;i++)
			{				
				if(i<(5-noFlipBook))
				{
					this.getChildByName("book"+i).visible=false;
					
				}else
				{
					this.getChildByName("book"+i).visible=true;
					
				}
				this.getChildByName("book"+i).x=(25+(145*i))-((5-noFlipBook)*145)/2;
				this.getChildByName("book"+i).y=140;
			}
			
			
			
		}
		
		function reset(e:MouseEvent)
		{
			hide1.gotoAndStop(1);
			hide2.gotoAndStop(1);
			hideBook1= false;
			hideBook2=false;
			for(var i=0;i<5;i++)
			{
				this.removeChild(this.getChildByName("book"+i));
			}
			initialize();
		}
		
		

	}
	
}
