﻿package  {
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	public class LengthConversion extends MovieClip {		
		private var convertionType:String;
		
		public function LengthConversion() {
			// constructor code
			initialize();
		}
		
		private function initialize()
		{
			convertionType="mmToCm";
			setConvertionType("mm","cm");
			
			mmToCm.gotoAndStop(3);
			enableButton(mmToCm);
			enableButton(cmToMm);
			enableButton(cmToM);
			enableButton(mToCm);
			enableButton(mToKm);
			enableButton(kmToM);
			enableButton(convert);
			
			convertionTxt.addEventListener(Event.CHANGE, textChange,false)
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		function textChange(e:Event)
		{
			convertedTxt.text="";
		}
		
		private function enableButton(btnName)
		{
			btnName.buttonMode=true;
			btnName.addEventListener(MouseEvent.MOUSE_OVER, btnMouseOver, false);
			btnName.addEventListener(MouseEvent.MOUSE_OUT, btnMouseOut, false);	
			btnName.addEventListener(MouseEvent.CLICK, btnClick, false);
			
		}
		private function setConvertionType(frmTxt,toTxt)
		{
			convertFrmTxt.text=frmTxt;
			convertToTxt.text=toTxt;
		}
										   
		function btnMouseOver(e:MouseEvent)
		{
			if(e.target.parent.currentFrame!=3)
			{
				e.target.parent.gotoAndStop(2);
			}
		}
		function btnMouseOut(e:MouseEvent)
		{
			if(e.target.parent.currentFrame!=3)
			{
				e.target.parent.gotoAndStop(1);
			}
			convert.gotoAndStop(1);
		}
		function btnClick(e:MouseEvent)
		{			
			if(e.target.parent.name!="convert")
			{
				mmToCm.gotoAndStop(1);
				cmToMm.gotoAndStop(1);
				cmToM.gotoAndStop(1);
				mToCm.gotoAndStop(1);
				mToKm.gotoAndStop(1);
				kmToM.gotoAndStop(1);
			}
			
			e.target.parent.gotoAndStop(3);
			
			
			
			if(e.target.parent.name=="convert")
			{
				convertLength(convertionType);				
			}else
			{			
				convertLength(e.target.parent.name);				
			}
		}
		
		private function convertLength(cType:String)
		{
			convertedTxt.text="";
			switch(cType)
			{
				case "mmToCm":
				convertionType="mmToCm";
				setConvertionType("mm","cm");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)/10);
				}
				break;
				case "cmToMm":
				convertionType="cmToMm";				
				setConvertionType("cm","mm");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)*10);
				}
				break;
				case "cmToM":
				convertionType="cmToM";
				setConvertionType("cm","m");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)/100);
				}
				break;
				case "mToCm":
				convertionType="mToCm";
				setConvertionType("m","cm");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)*100);
				}
				break;
				case "mToKm":
				convertionType="mToKm";
				setConvertionType("m","km");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)/1000);
				}
				break;
				case "kmToM":
				convertionType="kmToM";
				setConvertionType("km","m");
				if(convertionTxt.text!="")
				{
					convertedTxt.text=String(Number(convertionTxt.text)*1000);
				}
				break;
			}
			
		}
		function reset(e:MouseEvent)
		{
			convertionTxt.text="";
			convertedTxt.text="";
			convertionType="mmToCm";
			setConvertionType("mm","cm");
		}
		

	}
	
}
