﻿package{
import flash.display.Sprite;
import flash.display.MovieClip;
import flash.display.Shape;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.utils.getDefinitionByName;
import flash.events.MouseEvent;

public class FindTheTotal extends MovieClip{

	private var textHighlight:Array=new Array();
	//FindTheTotal class constructer.
	//----------------------------------------------------------------------------------------------
	public function FindTheTotal():void
	{
		init();		
	}
	//----------------------------------------------------------------------------------------------
	
	//Initialize function
	//----------------------------------------------------------------------------------------------
	private function init():void
	{
		trace("Find The Total");		
		//drawGrid();
		setRandomValue();
		generateTotalBtn.buttonMode=true;
		generateTotalBtn.mouseChildren=false;
		generateTotalBtn.addEventListener(MouseEvent.CLICK, generateTotal);
		reset_btn.addEventListener(MouseEvent.CLICK, reset);
	}
	//----------------------------------------------------------------------------------------------
	
	//Drawing a Grid
	//----------------------------------------------------------------------------------------------
	/*private function drawGrid():void
	{
		var grid:Shape=new Shape();		
		grid.graphics.lineStyle(1,0x000000,1);
		grid.graphics.moveTo(130,70);
		grid.graphics.lineTo(630,70);
		grid.graphics.lineTo(630,420);
		grid.graphics.lineTo(130,420);
		grid.graphics.lineTo(130,70);
		
		grid.graphics.moveTo(130,140);
		grid.graphics.lineTo(630,140);
		grid.graphics.moveTo(130,210);
		grid.graphics.lineTo(630,210);
		grid.graphics.moveTo(130,280);
		grid.graphics.lineTo(630,280);
		grid.graphics.moveTo(130,350);
		grid.graphics.lineTo(630,350);
		
		grid.graphics.moveTo(230,70);
		grid.graphics.lineTo(230,420);
		grid.graphics.moveTo(330,70);
		grid.graphics.lineTo(330,420);
		grid.graphics.moveTo(430,70);
		grid.graphics.lineTo(430,420);
		grid.graphics.moveTo(530,70);
		grid.graphics.lineTo(530,420);		
		addChild(grid);		
	}*/
	//----------------------------------------------------------------------------------------------
	
	
	//Creating a text field and set the random value.
	//----------------------------------------------------------------------------------------------
	private function setRandomValue()
	{
		var xPos:Number=0;
		var yPos:Number=0;
		var columnCount1:Number=0;
		var rowCount1:Number=0;		
		for(var i:int=1; i<=25;i++)
		{			
			
			var randomValue:Number=Math.floor(Math.random()*9999);
			var container:MovieClip=new numContainer();
			container.name="container"+i;
			container.txt.text=randomValue;
			container.txt.selectable=false;
			xPos=150+(90*columnCount1);
			yPos=10+(90*rowCount1);			
			columnCount1=columnCount1+1;
			
			if(columnCount1==5)
			{
				columnCount1=0;		
				rowCount1=rowCount1+1;				
			}
			container.x=xPos;
			container.y=yPos;
			
			container.mouseChildren=false;
			container.addEventListener(MouseEvent.CLICK, objClicked, false);
			container.doubleClickEnabled=true;
			container.addEventListener(MouseEvent.DOUBLE_CLICK, doubleClickText, false);
			addChild(container);
			/*var f=getDefinitionByName("ITC") as Class;
			var fnt=new f();
			
			var tempFormat:TextFormat=new TextFormat();
			tempFormat.size=20;
			tempFormat.bold=true;
			
			tempFormat.font = fnt.fontName;
			trace(tempFormat.font);
			tempFormat.align=TextFormatAlign.CENTER;			
			//tempFormat.font="ITCAvantGardeStd-Demi";
			
			var tempTextField:TextField=new TextField();			
			
			tempTextField.name=String(i);			
			tempTextField.text="\n"+String(randomValue);	
			tempTextField.setTextFormat(tempFormat);
			tempTextField.embedFonts=true;
			tempTextField.textColor=0x000000;
			tempTextField.multiline=true;
			tempTextField.selectable=false;
			tempTextField.background=true;
			tempTextField.backgroundColor=0xffffff;
			textHighlight[i]=false;
			xPos=130+(100*columnCount1);
			yPos=70+(70*rowCount1);			
			columnCount1=columnCount1+1;
			
			if(columnCount1==5)
			{
				columnCount1=0;		
				rowCount1=rowCount1+1;				
			}
			
			
			tempTextField.x=xPos;
			tempTextField.y=yPos;
			tempTextField.width=100;
			tempTextField.height=70;
			tempTextField.type="input";
			tempTextField.restrict="0-9";
			tempTextField.maxChars=4;
			tempTextField.border=true;		
			tempTextField.addEventListener(MouseEvent.CLICK, textFieldSelected,false);
			tempTextField.doubleClickEnabled=true;
			tempTextField.addEventListener(MouseEvent.DOUBLE_CLICK, doubleClickText, false);
			addChild(tempTextField);*/
			
		}
		//----------------------------------------------------------------------------------------------
		
		function objClicked(e:MouseEvent)
		{
			if(e.currentTarget.currentFrame==1)
			{
				e.currentTarget.gotoAndStop(2);
			}else
			{
				e.currentTarget.gotoAndStop(1);
			}
		}
		
		function doubleClickText(e:MouseEvent)
		{			
			
			var txtName=e.currentTarget.getChildByName("txt");
			e.currentTarget.gotoAndStop(1);
			txtName.selectable=true;			
			txtName.text="";
			txtName.stage.focus = txtName;
			
		}		
		
		
		
	}
	function reset(e:MouseEvent)
	{
		
		for(var i:int=1; i<=25;i++)
		{
			//trace(getChildByName(String(i)));
			removeChild(getChildByName("container"+i))
		}
		total.text="";
		setRandomValue();
		
	}

	function generateTotal(e:MouseEvent)
	{
			
		var randomValue:Number=Math.floor(Math.random()*(9999-1000)+1000);		
		total.text=String(randomValue);
	}

  }
}